do 

local oldunit = Unit 

Unit = Class(oldunit) {

    OnCreate = function(self)
		oldunit.OnCreate(self)
		self.SeenEver = false
		self.IntelThread = ForkThread(self.WatchIntelFromOthers, self)
    end,

    OnStartBeingBuilt = function(self, builder, layer)
		oldunit.OnStartBeingBuilt(self, builder, layer)
		local bp = self:GetBlueprint()
		local audio = bp.Audio
		local mybrain = self:GetAIBrain()
		for i, brain in ArmyBrains do
			if ArmyIsCivilian(brain:GetArmyIndex()) == false then
				local FactionName = mybrain:GetFactionName()
				if brain == mybrain then
					if audio['UnitStartBeingBuilt'..FactionName] then
						brain:UnitStartBeingBuilt(audio['UnitStartBeingBuilt'..FactionName])
					end
				elseif IsAlly(mybrain:GetArmyIndex(), brain:GetArmyIndex()) then
					if audio['AllyUnitStartBeingBuilt'..FactionName] then
						brain:AllyUnitStartBeingBuilt(audio['AllyUnitStartBeingBuilt'..FactionName], self:GetPosition())
					end
				end
			end
		end
    end,
    
    OnStopBeingBuilt = function(self, builder, layer)
		#necessary to prevent an 'Object has been destroyed' error
		KillThread(self.IntelThread)
		#IntelThread will be restarted at the end of this function
		oldunit.OnStopBeingBuilt(self, builder, layer)
		local bp = self:GetBlueprint()
		local audio = bp.Audio
		local mybrain = self:GetAIBrain()
		for i, brain in ArmyBrains do
			if ArmyIsCivilian(brain:GetArmyIndex()) == false then
				local FactionName = brain:GetFactionName()
				if brain == mybrain then
					if  audio['UnitComplete'..FactionName] then
						brain:UnitComplete(audio['UnitComplete'..FactionName], self:GetPosition())
					end
				elseif IsAlly(mybrain:GetArmyIndex(), brain:GetArmyIndex()) then
					if  audio['AllyUnitComplete'..FactionName] then
						brain:AllyUnitComplete(audio['AllyUnitComplete'..FactionName], self:GetPosition())
					end
				end
			end
		end
		#necessary to prevent an 'Object has been destroyed' error
		self.IntelThread = ForkThread(self.WatchIntelFromOthers, self)
	end,
    
    WatchIntelFromOthers = function(self)
		while true do
			for i, brain in ArmyBrains do
				if ArmyIsCivilian(brain:GetArmyIndex()) == false and IsEnemy(brain:GetArmyIndex(), self:GetAIBrain():GetArmyIndex()) then
					local index = brain:GetArmyIndex()
					local blip = self:GetBlip(index)
					if blip then
						local NowSeenEver = blip:IsSeenEver(index)
						if NowSeenEver == true and self.SeenEver == false then
							local bp = self:GetBlueprint()
							local audio = bp.Audio
							local FactionName = brain:GetFactionName()
							#if self:IsBeingBuilt() then
								if audio['EnemyUnitDetected'..FactionName] then
									brain:EnemyUnitDetected(audio['EnemyUnitDetected'..FactionName], self:GetPosition())
								end
							#else
							#	if audio['EnemyUnitBeingBuiltDetected'..FactionName] then
							#		brain:EnemyUnitBeingBuiltDetected(audio['EnemyUnitBeingBuiltDetected'..FactionName], self:GetPosition())
							#	end
							#end
						end
						self.SeenEver = NowSeenEver
					else
						self.SeenEver = false
					end
				end
			end
			WaitSeconds(1)
		end
    end,
    
    OnNukeArmed = function(self)
		local bp = self:GetBlueprint()
		local audio = bp.Audio
		local mybrain = self:GetAIBrain()
		for i, brain in ArmyBrains do
			if ArmyIsCivilian(brain:GetArmyIndex()) == false then
				if brain == mybrain then
					if audio['NukeArmed'..FactionName] then
						brain:NukeArmed(audio['NukeArmed'..FactionName], self:GetPosition())
					end
				elseif IsAlly(mybrain:GetArmyIndex(), brain:GetArmyIndex()) then
					if audio['AllyNukeArmed'..FactionName] then
						brain:AllyNukeArmed(audio['AllyNukeArmed'..FactionName], self:GetPosition())
					end				
				elseif IsEnemy(mybrain:GetArmyIndex(), brain:GetArmyIndex()) then
					if audio['EnemyNukeArmed'..FactionName] then
						brain:EnemyNukeArmed(audio['EnemyNukeArmed'..FactionName], self:GetPosition())
					end
				end
			end
		end
    end,
	
	OnDamageBy = function(self,index)
		oldunit.OnDamageBy(self, index)
        local bp = self:GetBlueprint()
		local audio = bp.Audio
		local mybrain = self:GetAIBrain()
		for i, brain in ArmyBrains do
			if ArmyIsCivilian(brain:GetArmyIndex()) == false then
				local FactionName = brain:GetFactionName()
				if brain == mybrain then
					if audio['UnitUnderAttack'..FactionName] then
						brain:UnitUnderAttack(audio['UnitUnderAttack'..FactionName], self:GetPosition())
					end
				elseif IsAlly(mybrain:GetArmyIndex(), brain:GetArmyIndex()) then
					if audio['AllyUnitUnderAttack'..FactionName] then
						brain:AllyUnitUnderAttack(audio['AllyUnitUnderAttack'..FactionName], self:GetPosition())
					end
				end
			end
		end
		local FactionName = mybrain:GetFactionName()
		if mybrain and ArmyIsCivilian(mybrain:GetArmyIndex()) == false then
			local HealthPercent = self:GetHealthPercent()
			local snd
			if HealthPercent < 0.78 and HealthPercent > 0.72 then
				if audio['HealthAt75'..FactionName] then
					snd = audio['HealthAt75'..FactionName]
				end
			elseif HealthPercent < 0.53 and HealthPercent > 0.47 then
				if audio['HealthAt50'..FactionName] then
					snd = audio['HealthAt50'..FactionName]
				end
			elseif HealthPercent < 0.28 and HealthPercent > 0.22 then
				if audio['HealthAt25'..FactionName] then
					snd = audio['HealthAt25'..FactionName]
				end
			elseif HealthPercent < 0.18 and HealthPercent > 0.12 then
				if audio['HealthAt15'..FactionName] then
					snd = audio['HealthAt15'..FactionName]
				end
			elseif HealthPercent < 0.12 and HealthPercent > 0.08 then
				if audio['HealthAt10'..FactionName] then
					snd = audio['HealthAt10'..FactionName]
				end
			elseif HealthPercent < 0.08 and HealthPercent > 0.02 then
				if audio['HealthAt05'..FactionName] then
					snd = audio['HealthAt05'..FactionName]
				end
			end
			if snd then
				mybrain:UnitHealthAt(snd)
			end
		end
    end,
    
    OnKilled = function(self, instigator, type, overkillRatio)
		oldunit.OnKilled(self, instigator, type, overkillRatio)
		KillThread(self.IntelThread)
	end,
	
    OnKilledVO = function(self)
		oldunit.OnKilledVO(self)
		local bp = self:GetBlueprint()
		local audio = bp.Audio
		local mybrain = self:GetAIBrain()
		for i, brain in ArmyBrains do
			if ArmyIsCivilian(brain:GetArmyIndex()) == false then
				local FactionName = brain:GetFactionName()
				if brain == mybrain then
					if audio['UnitDestroyed'..FactionName] then
						brain:UnitDestroyed(audio['UnitDestroyed'..FactionName], self:GetPosition())
					end
				elseif IsAlly(mybrain:GetArmyIndex(), brain:GetArmyIndex()) then
					if audio['AllyUnitDestroyed'..FactionName] then
						brain:AllyUnitDestroyed(audio['AllyUnitDestroyed'..FactionName], self:GetPosition())
					end
				else
					if audio['EnemyUnitDestroyed'..FactionName] then
						brain:EnemyUnitDestroyed(audio['EnemyUnitDestroyed'..FactionName], self:GetPosition())
					end
				end
			end
		end
    end,

} 

end 