do
	local oldModBps = ModBlueprints
	function ModBlueprints(all_blueprints)
		oldModBps(all_blueprints)
		local factions = {'UEF', 'Aeon', 'Cybran'}
		for i,bp in pairs(all_blueprints.Projectile) do
			if bp.Categories and bp.Description and bp.Audio then
				local categories = {}
				for j,category in pairs(bp.Categories) do
					categories[category] = true
				end
				for j,faction in pairs(factions) do
					if categories['STRATEGIC'] == true
					and categories['MISSILE'] == true then
						local MeIntercepted = Sound {
							Bank = 'COMPUTER_'..faction..'_VO',
							Cue = faction..'Computer_MissileLaunch_01353',}
						bp.Audio['ProjectileIntercepted'..faction] = MeIntercepted
						local InterceptedByMe = Sound {
							Bank = 'COMPUTER_'..faction..'_VO',
							Cue = faction..'Computer_MissileLaunch_01354',}
						bp.Audio['EnemyProjectileIntercepted'..faction] = InterceptedByMe
					end
				end
			end
		end
		for i,bp in pairs(all_blueprints.Unit) do
			local categories = {}
			for j,category in pairs(bp.Categories) do
				categories[category] = true
			end
			for j,faction in pairs(factions) do
				if categories['COMMAND'] == true then
					#DETECTED
					local Detected = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Intel_01198',}
					bp.Audio['EnemyUnitDetected'..faction] = Detected
					#WAS A SHAME
					local CommanderDestroyed = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Failed_01422',}
					bp.Audio['UnitDestroyed'..faction] = CommanderDestroyed
					#UNDER ATTACK
					local CommanderUnderAttack = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Commanders_01314',}
					bp.Audio['UnitUnderAttack'..faction] = CommanderUnderAttack
					#HEALTH WARNINGS
					local HealthAt75 = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Commanders_01323',}
					bp.Audio['HealthAt75'..faction] = HealthAt75
					local HealthAt50 = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Commanders_01322',}
					bp.Audio['HealthAt50'..faction] = HealthAt50
					local HealthAt25 = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Commanders_01324',}
					bp.Audio['HealthAt25'..faction] = HealthAt25
					local HealthAt15 = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Commanders_01325',}
					bp.Audio['HealthAt15'..faction] = HealthAt15
					local HealthAt05 = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Commanders_01327',}
					bp.Audio['HealthAt05'..faction] = HealthAt05
				end
				if categories['EXPERIMENTAL'] == true then
					#BEING BUILT
					local BeingBuiltByMe = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Expiremental_01366',}
					bp.Audio['UnitStartBeingBuilt'..faction] = BeingBuiltByMe
					local BeingBuiltByAlly = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Expiremental_01369',}
					bp.Audio['AllyUnitStartBeingBuilt'..faction] = BeingBuiltByAlly
					local BeingBuiltByEnemy = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Expiremental_01368',}
					bp.Audio['EnemyUnitStartBeingBuilt'..faction] = BeingBuiltByEnemy
					#BUILT COMPLETE
					local BuiltComplete = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Expiremental_01360',}
					bp.Audio['UnitComplete'..faction] = BuiltComplete
					#DETECTED
					local Detected = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Intel_01199',}
					bp.Audio['EnemyUnitDetected'..faction] = Detected
					#UNDER ATTACK
						local UnderAttack = Sound {
							Bank = 'COMPUTER_'..faction..'_VO',
							Cue = faction..'Computer_Expiremental_01361',}
						bp.Audio['UnitUnderAttack'..faction] = UnderAttack
					#DESTROYED
					local MeDestroyed = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Expiremental_01362',}
					bp.Audio['UnitDestroyed'..faction] = MeDestroyed
					local AllyDestroyed = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Expiremental_01364',}
					bp.Audio['AllyUnitDestroyed'..faction] = AllyDestroyed
					local EnemyDestroyed = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Expiremental_01365',}
					bp.Audio['EnemyUnitDestroyed'..faction] = EnemyDestroyed
				end
				if categories['STRATEGIC'] == true
				and categories['NUKE'] == true
				and categories['SILO'] == true then
					#DETECTED
					local Detected = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_MissileLaunch_01352',}
					bp.Audio['EnemyUnitDetected'..faction] = Detected
					#ARMED
					local NukeArmed = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_MissileLaunch_01344',}
					bp.Audio['NukeArmed'..faction] = NukeArmed
					#ENEMY ARMED
					#local EnemyNukeArmed = Sound {
					#	Bank = 'COMPUTER_'..faction..'_VO',
					#	Cue = faction..'Computer_MissileLaunch_01352',}
					#bp.Audio['EnemyNukeArmed'..faction] = EnemyNukeArmed
					#LAUNCH INITIATED
					local NuclearLaunchInitiated = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_MissileLaunch_01349',}
					bp.Audio['NuclearLaunchInitiatedBy'..faction] = NuclearLaunchInitiated
				end
				if categories['TRANSPORTATION'] == true then
					local FerrySet = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Transports_01328',}
					bp.Audio['FerryPointSetBy'..faction] = FerrySet
				end
				if categories['FACTORY'] and categories['STRUCTURE'] then
					#UNDER ATTACK
					local FactoryUnderAttack = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Combat_01218',}
					bp.Audio['UnitUnderAttack'..faction] = FactoryUnderAttack
				end
				if categories['MASSEXTRACTION'] then
					local MexUnderAttack = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Combat_01231',}
					bp.Audio['UnitUnderAttack'..faction] = MexUnderAttack
				end
				if categories['ENERGYPRODUCTION'] and not categories['COMMAND']then
					local GeneratorUnderAttack = Sound {
						Bank = 'COMPUTER_'..faction..'_VO',
						Cue = faction..'Computer_Combat_01232',}
					bp.Audio['UnitUnderAttack'..faction] = GeneratorUnderAttack
				end
			end
		end
	end
end