do

	local oldCreateUI = CreateUI
	CreateUI = function(isReplay)
		oldCreateUI(isReplay)
		local keyMap = import('/lua/keymap/defaultKeyMap.lua')
		IN_AddKeyMapTable(keyMap.AYVModKeyMap)
		ForkThread(UnitEventAlerts)
	end

	local GetOption = import('/lua/user/prefs.lua').GetOption
	local Ping = import("/lua/ui/game/ping.lua").DoPingOnPosition
	local VOStrings = import('/lua/ui/game/vo_computer.lua')
	local MissionText = import('/lua/ui/game/missiontext.lua')
		
	local LastAlertPos
	local OriginalPos
		
	UnitEventAlerts = function()
		while true do
			if UnitData.VOs then
				if table.getn(UnitData.VOs) > 0 then
					for index,vo in pairs(UnitData.VOs) do
						if vo.Text != "EnemyUnitDetected" or (vo.Text == "EnemyUnitDetected" and SessionGetScenarioInfo().Options.FogOfWar != 'none') then
							if vo.Marker and GetOption('vo_VisualAlertsMode') != 0 then
								Ping(vo.Marker.type, vo.Marker.position)
								LastAlertPos = vo.Marker.position
							end
							if GetOption('vo_'..vo.Text) != false then
								PlayVoice(Sound{Bank = vo.Bank, Cue = vo.Cue}, true)
							end
						end
					end
					UnitData.VOs = {}
				end
			end
			WaitSeconds(1)
		end
	end
	
	GoToLastAlert = function()
		if LastAlertPos then
			OriginalPos = GetCamera("WorldCamera"):SaveSettings()
			ForkThread(function()
				local cam = GetCamera("WorldCamera")
				local saved = cam:SaveSettings()
				local position = LastAlertPos
				local zoom = GetOption('alertcam_zoom')
				local closehpr = Vector(saved.Heading , 0.9, 0)
				local time = GetOption('alertcam_time') + 0.1
				local mode = GetOption('alertcam_mode')
				if mode == 1 then
					local dpos = {}
					for i,x in pairs(position) do
						table.insert(dpos, position[i] - 2 * saved.Focus[i])
					end
					WARN(repr(saved.Focus))
					WARN(repr(dpos))
					WARN(repr(position))
					local farhpr = Vector(saved.Heading , 1.5, 0)
					#cam:Reset()
					local mapview = cam:SaveSettings()
					#WARN(repr(mapview))
					#local farhpr = Vector(mapview.Heading , mapview.Pitch, 0)
					cam:MoveTo(dpos, farhpr, 350, time)
					WaitSeconds(time)
				end
				if mode == 5 then
					cam:Reset()
					WaitSeconds(0.5)
				end 
				if mode == 1 or mode == 2 or mode == 5 then
					cam:MoveTo(position, closehpr, zoom, time)
				elseif mode == 3 then
					cam:SnapTo(position, closehpr, zoom)
				elseif mode == 4 then
					cam:Reset()
				end
				cam:EnableEaseInOut()
			end)
		end
	end

	GoBackToAction = function()
		local cam = GetCamera("WorldCamera")
		cam:RestoreSettings(OriginalPos)
	end
	
end