do

	local GetOption = import('/lua/user/prefs.lua').GetOption

	HXPingTypes = {
		alertyellow = {Lifetime = 6, Mesh = 'alert_marker', Ring = '/game/marker/ring_yellow02-blur.dds', ArrowColor = 'red', Sound = 'UEF_Select_Radar'},
		alertred = {Lifetime = 6, Mesh = 'alert_marker', Ring = '/game/marker/ring_red02-blur.dds', ArrowColor = 'red', Sound = 'UEF_Select_Radar'},
		alertblue = {Lifetime = 6, Mesh = 'alert_marker', Ring = '/game/marker/ring_blue02-blur.dds', ArrowColor = 'blue', Sound = 'UEF_Select_Radar'},
		alertgreen = {Lifetime = 6, Mesh = 'alert_marker', Ring = '/game/marker/ring_green02-blur.png', ArrowColor = 'green', Sound = 'UEF_Select_Radar'},
	}

	DoPingOnPosition = function(pingType, position)
		#HX code
		PingTypes = table.merged(PingTypes, HXPingTypes)
		##
		if import('/lua/ui/game/gamemain.lua').supressExitDialog then return end
		for _, v in position do
			local var = v
			if var != v then
				return
			end
		end
		local army = GetArmiesTable().focusArmy - 1
		if GetFocusArmy() == -1 then
			return 
		end
		local data = {Owner = army, Type = pingType, Location = position, Type = pingType}
		#HX code
		if GetOption('vo_VisualAlertsMode') != 1 then
			data.DisplayMesh = true
		else
			data.DisplayMesh = false
		end
		data.AllwaysDisplayBitmap = (GetOption('vo_VisualAlertsMode') == 1)
		data.DisplayBitmap = (GetOption('vo_VisualAlertsMode') != 2)
		data.PlaySound = GetOption('vo_PingSound')
		##
		data = table.merged(data, PingTypes[pingType])
		if data.Marker then
			if markers[data.Owner] and table.getsize(markers[data.Owner]) >= MaxMarkers then
				UIUtil.QuickDialog(GetFrame(0), '<LOC markers_0001>You must delete an existing marker before making a new one.','<LOC _OK>', nil, nil, nil, nil, nil, true, {escapeButton = 1, enterButton = 1, worldCover = 1})
			else
				NamePing(function(name)
					data.Name = name
					local armies = GetArmiesTable()
					data.Color = armies.armiesTable[armies.focusArmy].color
					SimCallback({Func = 'SpawnPing', Args = data})
				end)
			end
		else
			SimCallback({Func = 'SpawnPing', Args = data})
		end
	end
	
	DisplayPing = function(data)
		--Table of all map views to display pings in
		local views = import('/lua/ui/game/worldview.lua').GetWorldViews()
		for index, ping in data do
			for _, viewControl in views do
				if viewControl and ping.Action != 'renew' then
					if ping.Action then
						viewControl:UpdatePing(ping)
						if ping.Action == 'delete' then
							markers[ping.Owner][ping.ID] = nil
						elseif ping.Action == 'flush' then
							markers = {}
						end
					else
						viewControl:DisplayPing(ping)
						if ping.Marker then
							if not markers[ping.Owner] then markers[ping.Owner] = {} end
							markers[ping.Owner][ping.ID] = ping
						end
					end
				end
			end
			#HX code (line 71)
			if ping.Sound and ping.PlaySound != false and not ping.Renew then
				PlaySound(Sound{Bank = 'Interface', Cue = ping.Sound})
			end
		end
	end

end